package org.kohsuke.rng2srng.datatype;

import java.util.ArrayList;
import java.util.List;

import org.relaxng.datatype.Datatype;
import org.relaxng.datatype.DatatypeBuilder;
import org.relaxng.datatype.DatatypeException;
import org.relaxng.datatype.ValidationContext;

/**
 * 
 * 
 * @author Kohsuke Kawaguchi (kk@kohsuke.org)
 */
class DatatypeBuilderImpl implements DatatypeBuilder {
    DatatypeBuilderImpl( String nsURI, String dtName ) {
        this.nsURI = nsURI;
        this.dtName = dtName;
    }    
    
    private final String nsURI,dtName;

    public void addParameter(String name, String value, ValidationContext context)
        throws DatatypeException {
            
        parameters.add( new String[]{name,value} );
    }
    
    private List parameters = new ArrayList();

    public Datatype createDatatype() throws DatatypeException {
        return new DatatypeImpl( nsURI, dtName, new ArrayList(parameters) );
    }

}
